#ifndef _24L01_H
#define _24L01_H
#include<reg52.h>
#include<intrins.h>
#define uchar unsigned char
#define uint unsigned int
//****************************************IO˿ڶ*********************************************
//nRF24L01Ŷ
sbit MISO=P0^5;//
sbit MOSI=P0^7;//
sbit SCK=P0^4;//ʱ
sbit CE=P0^3;//ģʽѡ
sbit CSN=P0^2;//Ƭѡ
sbit IRQ=P0^6;//ж 
//*************************************NRF24L01**************************************************
//NRF24L01Ĵ
#define NRF24L01_READ_REG        0x00  //üĴ,5λΪĴַ
#define NRF24L01_WRITE_REG       0x20  //дüĴ,5λΪĴַ
#define NRF24L01_RD_RX_PLOAD     0x61  //RXЧ,1~32ֽ
#define NRF24L01_WR_TX_PLOAD     0xA0  //дTXЧ,1~32ֽ
#define NRF24L01_FLUSH_TX        0xE1  //TX FIFOĴ.ģʽ
#define NRF24L01_FLUSH_RX        0xE2  //RX FIFOĴ.ģʽ
#define NRF24L01_REUSE_TX_PL     0xE3  //ʹһ,CEΪ,ݰϷ.
#define NRF24L01_NOP             0xFF  //ղ,״̬Ĵ
//SPI(NRF24L01)Ĵַ
#define CONFIG          0x00  //üĴַ;bit0:1ģʽ,0ģʽ;bit1:ѡ;bit2:CRCģʽ;bit3:CRCʹ;
                              //bit4:жMAX_RT(ﵽطж)ʹ;bit5:жTX_DSʹ;bit6:жRX_DRʹ
#define EN_AA           0x01  //ʹԶӦ  bit0~5,Ӧͨ0~5
#define EN_RXADDR       0x02  //յַ,bit0~5,Ӧͨ0~5
#define SETUP_AW        0x03  //õַ(ͨ):bit1,0:00,3ֽ;01,4ֽ;02,5ֽ;
#define SETUP_RETR      0x04  //Զط;bit3:0,Զط;bit7:4,Զطʱ 250*x+86us
#define RF_CH           0x05  //RFͨ,bit6:0,ͨƵ;
#define RF_SETUP        0x06  //RFĴ;bit3:(0:1Mbps,1:2Mbps);bit2:1,书;bit0:Ŵ
#define STATUS          0x07  //״̬Ĵ;bit0:TX FIFO־;bit3:1,ͨ(:6);bit4,ﵽط
                              //bit5:ݷж;bit6:ж;
#define MAX_TX  		0x10  //ﵽʹж
#define TX_OK   		0x20  //TXж
#define RX_OK   		0x40  //յж

#define OBSERVE_TX      0x08  //ͼĴ,bit7:4,ݰʧ;bit3:0,ط
#define CD              0x09  //زĴ,bit0,ز;
#define RX_ADDR_P0      0x0A  //ͨ0յַ,󳤶5ֽ,ֽǰ
#define RX_ADDR_P1      0x0B  //ͨ1յַ,󳤶5ֽ,ֽǰ
#define RX_ADDR_P2      0x0C  //ͨ2յַ,ֽڿ,ֽ,ͬRX_ADDR_P1[39:8];
#define RX_ADDR_P3      0x0D  //ͨ3յַ,ֽڿ,ֽ,ͬRX_ADDR_P1[39:8];
#define RX_ADDR_P4      0x0E  //ͨ4յַ,ֽڿ,ֽ,ͬRX_ADDR_P1[39:8];
#define RX_ADDR_P5      0x0F  //ͨ5յַ,ֽڿ,ֽ,ͬRX_ADDR_P1[39:8];
#define TX_ADDR         0x10  //͵ַ(ֽǰ),ShockBurstTMģʽ,RX_ADDR_P0˵ַ
#define RX_PW_P0        0x11  //ͨ0Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P1        0x12  //ͨ1Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P2        0x13  //ͨ2Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P3        0x14  //ͨ3Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P4        0x15  //ͨ4Чݿ(1~32ֽ),Ϊ0Ƿ
#define RX_PW_P5        0x16  //ͨ5Чݿ(1~32ֽ),Ϊ0Ƿ
#define FIFO_STATUS     0x17  //FIFO״̬Ĵ;bit0,RX FIFOĴձ־;bit1,RX FIFO־;bit2,3,
                              //bit4,TX FIFOձ־;bit5,TX FIFO־;bit6,1,ѭһݰ.0,ѭ;
//////////////////////////////////////////////////////////////////////////////////////////////////////////
//24L01ͽݿȶ
#define TX_ADR_WIDTH    5   //5ֽڵĵַ
#define RX_ADR_WIDTH    5   //5ֽڵĵַ
#define TX_PLOAD_WIDTH  32  //20ֽڵûݿ
#define RX_PLOAD_WIDTH  32  //20ֽڵûݿ
//////////////////////////////////////////////////////////////////////////////////////////////////////////
const uchar TX_ADDRESS[TX_ADR_WIDTH]={0x34,0x43,0x10,0x10,0x01}; //͵ַ
const uchar RX_ADDRESS[RX_ADR_WIDTH]={0x34,0x43,0x10,0x10,0x01}; //͵ַ
////******************************************************************************************
/****************************************************************************************************
/*uchar SPI_RW(uchar adata)
/*ܣ51ƬģSPIдʱ
/****************************************************************************************************/
uchar SPI_RW(uchar adata)
{
	 uint i;
	    for(i=0;i<8;i++) 			     //8λݴ
	    {
		  MOSI = (adata & 0x80);         //뵽MOSI˿, MSB to MOSI
		  adata = (adata << 1);          // shift next bit into MSB..
		  SCK = 1;                       // SCK 
		  adata |= MISO;                 //MISOȡݵƬ
		  SCK = 0;                       // SCK 
	    }
	    return(adata);                   // ؽ
}
/****************************************************************************************************
/*uchar NRF24L01_Read_Reg(uchar reg)
/*ܣNRF24L01SPIʱ
/****************************************************************************************************/
uchar NRF24L01_Read_Reg(uchar reg)
{
	 uchar reg_val;
	 CSN = 0;                //ʹSPI
	 SPI_RW(reg);            //reg
	 reg_val = SPI_RW(0xFF); //ȡĴֵ
	 CSN = 1;                //ֹSPI
	 
	 return(reg_val);        //״ֵ̬
}
/****************************************************************************************************/
/*uchar NRF24L01_Write_Reg(uchar reg, uchar value)
//reg:ָĴַ
//value:дֵ
/*ܣNRF24L01дĴ
/****************************************************************************************************/
uchar NRF24L01_Write_Reg(uchar reg, uchar value)
{
	 uchar status;
	 CSN = 0;                   // ʹSPI
	 status = SPI_RW(reg);      // reg
	 SPI_RW(value);             // дĴֵ
	 CSN = 1;                   // ֹSPI	
	 
	 return(status);            // ״ֵ̬
}
/****************************************************************************************************/
/*uchar NRF24L01_Read_Buf(uchar reg, uchar *pBuf, uchar len)
/*: ָλöָȵ
/*regΪĴַpBufΪݵַlenݵĸ
/****************************************************************************************************/
uchar NRF24L01_Read_Buf(uchar reg, uchar *pBuf, uchar len)
{
	 uchar status,uchar_ctr;
	 CSN = 0;                      // ʹSPI
	 status = SPI_RW(reg);         // ͼĴֵ(λ),ȡ״ֵ̬
	 
	 for(uchar_ctr=0;uchar_ctr<len;uchar_ctr++)
	  pBuf[uchar_ctr] = SPI_RW(0xFF);    //// 
	 
	 CSN = 1;                      //ֹSPI     
	 
	 return(status);               // ض״ֵ̬
}
/*********************************************************************************************************
/*uchar NRF24L01_Write_Buf(uchar reg, uchar *pBuf, uchar len)
/*: дݣΪĴַpBufΪдݵַucharsдݵĸ
/*********************************************************************************************************/
uchar NRF24L01_Write_Buf(uchar reg, uchar *pBuf, uchar len)
{
	 uint status,uchar_ctr;
	 
	 CSN = 0;            //ʹSPI       
	 status = SPI_RW(reg);   
	 for(uchar_ctr=0; uchar_ctr<len; uchar_ctr++) 
	 	SPI_RW(*pBuf++);	//д
	 CSN = 1;           //ֹSPI  
	 return(status);    // 
}

/******************************************************************************************************/
/*NRF24L01һ
/*txbuf:׵ַ
/*ֵ:״
/******************************************************************************************************/
uchar NRF24L01_TxPacket(uchar *txbuf)
	{
	uchar sta;  
	CE=0;
	NRF24L01_Write_Buf(NRF24L01_WR_TX_PLOAD,txbuf,TX_PLOAD_WIDTH);//дݵTX BUF  32ֽ
	CE=1;//	   
	while(IRQ!=0);//ȴ
	sta=NRF24L01_Read_Reg(STATUS);  //ȡ״̬Ĵֵ	   
	NRF24L01_Write_Reg(NRF24L01_WRITE_REG+STATUS,sta); //TX_DSMAX_RTжϱ־
	if(sta&MAX_TX)//ﵽط
		{
		NRF24L01_Write_Reg(NRF24L01_FLUSH_TX,0xff);//TX FIFOĴ 
		return MAX_TX; 
		}
	if(sta&TX_OK)//
		{
		return TX_OK;
		}
	return 0xff;//ԭʧ
	}
/******************************************************************************************************/
/*NRF24L01һ
/*txbuf:׵ַ
/*ֵ:0ɣ
/******************************************************************************************************/
uchar NRF24L01_RxPacket(uchar *rxbuf)
{
	uchar sta;		    							   
	sta=NRF24L01_Read_Reg(STATUS);  //ȡ״̬Ĵֵ    	 
	NRF24L01_Write_Reg(NRF24L01_WRITE_REG+STATUS,sta); //TX_DSMAX_RTжϱ־
	if(sta&RX_OK)//յ
		{
		NRF24L01_Read_Buf(NRF24L01_RD_RX_PLOAD,rxbuf,RX_PLOAD_WIDTH);//ȡ
		NRF24L01_Write_Reg(NRF24L01_FLUSH_RX,0xff);//RX FIFOĴ 
		return 0; 
		}	   
	return 1;//ûյκ
}
/****************************************************************************************************/
/*void RX_Mode(void)
/*ܣݽ 
/****************************************************************************************************/
void RX_Mode(void)
{
	CE=0;	  
	NRF24L01_Write_Buf(NRF24L01_WRITE_REG+RX_ADDR_P0,(uchar*)RX_ADDRESS,RX_ADR_WIDTH);//дRXڵַ
	
	NRF24L01_Write_Reg(NRF24L01_WRITE_REG+EN_AA,0x01);    //ʹͨ0ԶӦ    
	NRF24L01_Write_Reg(NRF24L01_WRITE_REG+EN_RXADDR,0x01);//ʹͨ0Ľյַ  	 
	NRF24L01_Write_Reg(NRF24L01_WRITE_REG+RF_CH,40);	     //RFͨƵ		  
	NRF24L01_Write_Reg(NRF24L01_WRITE_REG+RX_PW_P0,RX_PLOAD_WIDTH);//ѡͨ0Чݿ 	    
	NRF24L01_Write_Reg(NRF24L01_WRITE_REG+RF_SETUP,0x0f);//TX,0db,2Mbps,濪   
	NRF24L01_Write_Reg(NRF24L01_WRITE_REG+CONFIG, 0x0f);//ûģʽĲ;PWR_UP,EN_CRC,16BIT_CRC,ģʽ 
	CE=1; //CEΪ,ģʽ
}
/****************************************************************************************************/
/*void TX_Mode(void)
/*ܣݷ 
/****************************************************************************************************/
void TX_Mode(void)
	{														 
	CE=0;	    
	NRF24L01_Write_Buf(NRF24L01_WRITE_REG+TX_ADDR,(uchar*)TX_ADDRESS,TX_ADR_WIDTH);//дTXڵַ 
	NRF24L01_Write_Buf(NRF24L01_WRITE_REG+RX_ADDR_P0,(uchar*)RX_ADDRESS,RX_ADR_WIDTH); //TXڵַ,ҪΪʹACK	  
	
	NRF24L01_Write_Reg(NRF24L01_WRITE_REG+EN_AA,0x01);     //ʹͨ0ԶӦ    
	NRF24L01_Write_Reg(NRF24L01_WRITE_REG+EN_RXADDR,0x01); //ʹͨ0Ľյַ  
	NRF24L01_Write_Reg(NRF24L01_WRITE_REG+SETUP_RETR,0x1a);//Զطʱ:500us + 86us;Զط:10
	NRF24L01_Write_Reg(NRF24L01_WRITE_REG+RF_CH,40);       //RFͨΪ40
	NRF24L01_Write_Reg(NRF24L01_WRITE_REG+RF_SETUP,0x0f);  //TX,0db,2Mbps,濪   
	NRF24L01_Write_Reg(NRF24L01_WRITE_REG+CONFIG,0x0e);    //ûģʽĲ;PWR_UP,EN_CRC,16BIT_CRC,ģʽ,ж
	CE=1;//CEΪ,10us
	}
void NRF24L01_Init(void)
{
	SCK=0;	// SPI߳ʼΪ
	IRQ=1;
	CE=0;	 //ʹ24L01  NRF24L01_CE
	CSN=1;    //SPIƬѡȡ NRF24L01_CSN	 		  
}
#endif
   		